// namespace object
if ("undefined" == typeof(BFolders)) {
  var BFolders = {};
};

// debug switch
BFolders._debug = false;

function bf_doit() {
	try {
		BFolders.log("checkpoint 2");
	
		var login = {};
		login.username = "uuuu";
		login.password = "pppp";
		login.loginAid = "aaaa";	
	
		bf_processWnd(top, login);
	} catch(e) {
		BFolders.log("Exception: " + e.message);
	}	
}

function bf_processWnd(wnd, loginInfo) {
	BFolders.log(wnd.location + " with " + wnd.frames.length + " child frames" );

	if (BFolders.canAutofill(wnd.document)) {
		loginInfo.doc = wnd.document; // piggybacking
		BFolders.autofill(loginInfo);
	}

	for (var i = 0; i < wnd.frames.length; i++) {
		try {
			var frm = wnd.frames[i]; 
			bf_processWnd(frm);
		} catch(e) {
			BFolders.log("Skipping a frame because:" + e.message);
		}		
	}
}


BFolders.canAutofill = function(doc) {
	for (var i = 0; i < doc.forms.length; i++) {
	
		var fields = this._getFormFields(doc.forms[i], false);
		var usernameField = fields[0];
		var newPasswordField = fields[1];
		var oldPasswordField = fields[2];

		// some sites require only a password as a confirmation for a transaction
		// so do not check the username
		 
		// do not fill password change forms!
		// they have 3 password fields so we would get 2 passwords
		if (newPasswordField && !oldPasswordField)
			return true; 
	}
	
	return false;
}

BFolders.autofill = function(loginInfo) {
	for (var i = 0; i < loginInfo.doc.forms.length; i++) {
		var form = loginInfo.doc.forms[i];
		var fields = this._getFormFields(form, false);	
		var usernameField = fields[0];
		var passwordField = fields[1];
		
		if (!passwordField || passwordField.disabled || passwordField.readOnly)
			continue;
		
		if (usernameField && (usernameField.disabled || usernameField.readOnly)) 
        	continue;
        	
        // TODO consider if we should check the value of fields, some
        // web sites pre-fill those fields with hints (e.g. password, email) and
        // clear them with JS code
        	
        if (!passwordField.value) {
        	passwordField.value = loginInfo.password;
			passwordField.setAttribute("bf_isautofilled", "true");
        }
        
        if (usernameField && !usernameField.value) {
        	usernameField.value = loginInfo.username;
			usernameField.setAttribute("bf_isautofilled", "true");
        }
        
        if (loginInfo.loginAid == "S") {
        	// login aid is autofill & submit
        	form.submit();
        
        	// one form is submitted, no need to process other forms
        	break;
        }
	}
}


bf_doit();