var bf_debug = false;

bf_doit();

function bf_doit() {
	try {
		bf_processWnd(top);
	} catch(e) {
		if (bf_debug) {
			top.alert("Exception: " + e.message);
		}
	}	
}

function bf_processWnd(wnd) {
	if (bf_debug) {
		top.alert(wnd.location + " with " + wnd.frames.length + " child frames" );
	}

	bf_processDoc(wnd.document);

	for (var i = 0; i < wnd.frames.length; i++) {
		try {
			var frm = wnd.frames[i]; 
			bf_processWnd(frm);
		} catch(e) {
			if (bf_debug) {
				top.alert("Skipping a frame because:" + e.message);
			}
		}		
	}
}

function bf_processDoc(doc) {
	var inputs = doc.getElementsByTagName("input");

	if (bf_debug) {
		var msg = "processDoc with " + inputs.length + " inputs.";
		
		msg += " Input names: ";
		for (var i = 0; i < inputs.length; i++) {
			msg += inputs[i].name + ", ";
		}
		
		top.alert(msg);
	}	
	
	var passwordInput = null;
	var indexOfPassword = 0;
	for (; indexOfPassword < inputs.length; indexOfPassword++) {
		var input = inputs[indexOfPassword];
		
		if (bf_debug) {
			top.alert("Checking name:" + input.name + " type:" + input.type + " value:" + input.value);
		}
		
		if (input.type == "password") {
			passwordInput = input;
			break;
		}
	}
	
	if (passwordInput == null) {
		for (indexOfPassword = 0; indexOfPassword < inputs.length; indexOfPassword++) {
			var input = inputs[indexOfPassword];
			if (input.type == "text" && input.value.toLowerCase() == "password") {
				passwordInput = input;
				break;
			}			
		}
	}
	
	var usernameInput = null;
	if (passwordInput != null) {
		if (bf_debug) {
			top.alert("indexOfPassword="+ indexOfPassword);
		}
	
		for (var indexOfUsername = indexOfPassword - 1; indexOfUsername >= 0; indexOfUsername--) {
			var input = inputs[indexOfUsername];
			if (input.type == "text" || input.type == "email") {
				usernameInput = input;
				break;
			}
		}
	}
	
	if (passwordInput != null) {
		if (bf_debug) {
			top.alert("Putting password in " + passwordInput.name);
		}
		passwordInput.value = "pppp";
	}

	if (usernameInput != null) {		
		if (bf_debug) {
			top.alert("Putting username in " + usernameInput.name);
		}
		usernameInput.value = "uuuu";
	}
}
